=== debian/changelog ===
ectrans (1.7.0-4) unstable; urgency=medium

  * Add d/gbp.conf
  * Use dh_fortran to get FMODDIR, flags
  * Use pre-computed DEB_HOST_MULTIARCH
  * Move d/watch to v5 syntax
  * Standards-Version: 4.7.3
  * Drop Priority: optional from source in d/control per new policy
  * Include d/salsa-ci.yml

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 13 Jan 2026 17:44:25 +0000

ectrans (1.7.0-3) unstable; urgency=medium

  * Fix d/copyright for licensecheck: use Apache-2.0
  * d/control: include XB-X-ROCm-GPU-Architecture
  * Patch from Cordell Bloor update d/control for ROCm 6.4.3

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Dec 2025 16:24:27 +0000

ectrans (1.7.0-2) unstable; urgency=medium

  * Drop dep on librocsolver-dev. Closes: #1120014

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 20 Nov 2025 11:24:19 +0000

ectrans (1.7.0-1) unstable; urgency=medium

  * New upstream release
  * Shorten description in d/control
  * Move d/watch to version=4 syntax

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 25 Oct 2025 10:31:07 +0100
